#ifndef EFL_GENERATED_EVAS_3D_SCENE_HH
#define EFL_GENERATED_EVAS_3D_SCENE_HH

extern "C"
{
#include <Efl.h>
}
#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "evas_3d_scene.eo.h"
}

#include "evas_3d_object.eo.hh"
#include "evas_common_interface.eo.hh"

struct evas_3d_scene
      : evas_3d_object,
      efl::eo::detail::extension_inheritance<evas::common_interface>::template type< ::evas_3d_scene>

{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit evas_3d_scene(Eo* eo)
      : evas_3d_object(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit evas_3d_scene(std::nullptr_t)
      : evas_3d_object(nullptr)
   {}

   /// @brief Call the object's constructor.
   /// Should not be used with #eo_do. Only use it with #eo_do_super.
   ///
   evas_3d_scene(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : evas_3d_scene(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   evas_3d_scene(evas_3d_scene const& other)
      : evas_3d_object(eo_ref(other._eo_ptr()))
   {}

   ~evas_3d_scene() {}

   /// @brief Pure virtual update_notify function..
   /// Update request for the object.
   ///
   void update_notify() const
   {
      eo_do(_eo_ptr(), ::evas_3d_object_update_notify());
   }

   /// @brief Pure virtual change_notify function..
   /// Update request for the object.
   ///
   /// @param state State that is changed
   /// @param ref The Object that caused the change
   ///
   void change_notify(Evas_3D_State state_, Evas_3D_Object * ref_) const
   {
      eo_do(_eo_ptr(), ::evas_3d_object_change_notify(state_, ref_));
   }

   /// @param node A node which will be used as a root node for the scene.
   ///
   Evas_3D_Node * root_node_get() const
   {
      Evas_3D_Node * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::evas_3d_scene_root_node_get());
      return _tmp_ret;
   }

   /// @param node A node which will be used as a root node for the scene.
   ///
   void root_node_set(Evas_3D_Node * node_) const
   {
      eo_do(_eo_ptr(), ::evas_3d_scene_root_node_set(node_));
   }

   /// @param node A node which will be used as a camera node for the scene.
   ///
   Evas_3D_Node * camera_node_get() const
   {
      Evas_3D_Node * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::evas_3d_scene_camera_node_get());
      return _tmp_ret;
   }

   /// @param node A node which will be used as a camera node for the scene.
   ///
   void camera_node_set(Evas_3D_Node * node_) const
   {
      eo_do(_eo_ptr(), ::evas_3d_scene_camera_node_set(node_));
   }

   /// @param w Width of the resolution.
   /// @param h Height of the resolution.
   ///
   void size_set(int w_, int h_) const
   {
      eo_do(_eo_ptr(), ::evas_3d_scene_size_set(w_, h_));
   }

   /// @param[out] w Pointer to receive width of the resolution.
   /// @param[out] h Pointer to receive height of the resolution.
   ///
   void size_get(int* w_, int* h_) const
   {
      eo_do(_eo_ptr(), ::evas_3d_scene_size_get(w_, h_));
   }

   /// @param r Red component of the background color.
   /// @param g Green component of the background color.
   /// @param b Blue component of the background color.
   /// @param a Alpha component of the background color.
   ///
   void background_color_set(Evas_Real r_, Evas_Real g_, Evas_Real b_, Evas_Real a_) const
   {
      eo_do(_eo_ptr(), ::evas_3d_scene_background_color_set(r_, g_, b_, a_));
   }

   /// @param[out] r Pointer to receive red component of the background color.
   /// @param[out] g Pointer to receive green component of the background color.
   /// @param[out] b Pointer to receive blue component of the background color.
   /// @param[out] a Pointer to receive alpha component of the background color.
   ///
   void background_color_get(Evas_Real* r_, Evas_Real* g_, Evas_Real* b_, Evas_Real* a_) const
   {
      eo_do(_eo_ptr(), ::evas_3d_scene_background_color_get(r_, g_, b_, a_));
   }

   /// @param x X coordinate of the picking position.
   /// @param y Y coordinate of the picking position.
   /// @param[out] node Pointer to receive the node contains the picked mesh.
   /// @param[out] mesh Pointer to receive the picked mesh.
   /// @param[out] s Pointer to receive the texture "s" coordinate.
   /// @param[out] t Pointer to receive the texture "t" coordinate.
   ///
   bool pick(Evas_Real x_, Evas_Real y_, Evas_3D_Node ** node_, Evas_3D_Mesh ** mesh_, Evas_Real* s_, Evas_Real* t_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::evas_3d_scene_pick(x_, y_, node_, mesh_, s_, t_));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param x X coordinate of the picking position.
   /// @param y Y coordinate of the picking position.
   /// @param node Node for search.
   ///
   Evas_3D_Node * exist(Evas_Real x_, Evas_Real y_, Evas_3D_Node * node_) const
   {
      Evas_3D_Node * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::evas_3d_scene_exist(x_, y_, node_));
      return _tmp_ret;
   }

   /// @param x X coordinate of the picking position.
   /// @param y Y coordinate of the picking position.
   ///
   efl::eina::range_list< Evas_3D_Node * > pick_member_list_get(Evas_Real x_, Evas_Real y_) const
   {
      Eina_List * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::evas_3d_scene_pick_member_list_get(x_, y_));
      return efl::eolian::to_cxx<efl::eina::range_list< Evas_3D_Node * >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
   }

   /// @param shadows_enabled shadows enabled status.
   ///
   void shadows_enable_set(bool shadows_enabled_) const
   {
      eo_do(_eo_ptr(), ::evas_3d_scene_shadows_enable_set(efl::eolian::to_c(shadows_enabled_)));
   }

   bool shadows_enable_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::evas_3d_scene_shadows_enable_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   static Eo_Class const* _eo_class()
   {
      return(EVAS_3D_SCENE_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_ref(EVAS_3D_SCENE_CLASS, _p._eo_raw, eo_constructor());
   }

};
template <typename T>
void _evas_3d_scene_update_notify_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   static_cast<T*>(self->this_)->update_notify();
}

template <typename T>
void _evas_3d_scene_change_notify_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_3D_State state_, Evas_3D_Object * ref_)
{
   static_cast<T*>(self->this_)->change_notify(state_, ref_);
}

template <typename T>
Evas_3D_Node * _evas_3d_scene_root_node_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->root_node_get();
}

template <typename T>
void _evas_3d_scene_root_node_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_3D_Node * node_)
{
   static_cast<T*>(self->this_)->root_node_set(node_);
}

template <typename T>
Evas_3D_Node * _evas_3d_scene_camera_node_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->camera_node_get();
}

template <typename T>
void _evas_3d_scene_camera_node_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_3D_Node * node_)
{
   static_cast<T*>(self->this_)->camera_node_set(node_);
}

template <typename T>
void _evas_3d_scene_size_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int w_, int h_)
{
   static_cast<T*>(self->this_)->size_set(w_, h_);
}

template <typename T>
void _evas_3d_scene_size_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int* w_, int* h_)
{
   static_cast<T*>(self->this_)->size_get(w_, h_);
}

template <typename T>
void _evas_3d_scene_background_color_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Real r_, Evas_Real g_, Evas_Real b_, Evas_Real a_)
{
   static_cast<T*>(self->this_)->background_color_set(r_, g_, b_, a_);
}

template <typename T>
void _evas_3d_scene_background_color_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Real* r_, Evas_Real* g_, Evas_Real* b_, Evas_Real* a_)
{
   static_cast<T*>(self->this_)->background_color_get(r_, g_, b_, a_);
}

template <typename T>
bool _evas_3d_scene_pick_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Real x_, Evas_Real y_, Evas_3D_Node ** node_, Evas_3D_Mesh ** mesh_, Evas_Real* s_, Evas_Real* t_)
{
   return static_cast<T*>(self->this_)->pick(x_, y_, node_, mesh_, s_, t_);
}

template <typename T>
Evas_3D_Node * _evas_3d_scene_exist_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Real x_, Evas_Real y_, Evas_3D_Node * node_)
{
   return static_cast<T*>(self->this_)->exist(x_, y_, node_);
}

template <typename T>
efl::eina::range_list< Evas_3D_Node * > _evas_3d_scene_pick_member_list_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Real x_, Evas_Real y_)
{
   return static_cast<T*>(self->this_)->pick_member_list_get(x_, y_);
}

template <typename T>
void _evas_3d_scene_shadows_enable_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool shadows_enabled_)
{
   static_cast<T*>(self->this_)->shadows_enable_set(efl::eolian::to_cxx<bool>(shadows_enabled_, std::tuple<std::false_type>()));
}

template <typename T>
bool _evas_3d_scene_shadows_enable_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->shadows_enable_get();
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::evas_3d_scene >
{
   template <typename T>
   struct type
   {
      virtual void update_notify()
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_3d_object_update_notify());
      }

      virtual void change_notify(Evas_3D_State state_, Evas_3D_Object * ref_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_3d_object_change_notify(state_, ref_));
      }

      virtual Evas_3D_Node * root_node_get()
      {
         Evas_3D_Node * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_scene_root_node_get());
            return _tmp_ret;
      }

      virtual void root_node_set(Evas_3D_Node * node_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_3d_scene_root_node_set(node_));
      }

      virtual Evas_3D_Node * camera_node_get()
      {
         Evas_3D_Node * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_scene_camera_node_get());
            return _tmp_ret;
      }

      virtual void camera_node_set(Evas_3D_Node * node_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_3d_scene_camera_node_set(node_));
      }

      virtual void size_set(int w_, int h_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_3d_scene_size_set(w_, h_));
      }

      virtual void size_get(int* w_, int* h_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_3d_scene_size_get(w_, h_));
      }

      virtual void background_color_set(Evas_Real r_, Evas_Real g_, Evas_Real b_, Evas_Real a_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_3d_scene_background_color_set(r_, g_, b_, a_));
      }

      virtual void background_color_get(Evas_Real* r_, Evas_Real* g_, Evas_Real* b_, Evas_Real* a_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_3d_scene_background_color_get(r_, g_, b_, a_));
      }

      virtual bool pick(Evas_Real x_, Evas_Real y_, Evas_3D_Node ** node_, Evas_3D_Mesh ** mesh_, Evas_Real* s_, Evas_Real* t_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_scene_pick(x_, y_, node_, mesh_, s_, t_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual Evas_3D_Node * exist(Evas_Real x_, Evas_Real y_, Evas_3D_Node * node_)
      {
         Evas_3D_Node * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_scene_exist(x_, y_, node_));
            return _tmp_ret;
      }

      virtual efl::eina::range_list< Evas_3D_Node * > pick_member_list_get(Evas_Real x_, Evas_Real y_)
      {
         Eina_List * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_scene_pick_member_list_get(x_, y_));
            return efl::eolian::to_cxx<efl::eina::range_list< Evas_3D_Node * >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
      }

      virtual void shadows_enable_set(bool shadows_enabled_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_3d_scene_shadows_enable_set(efl::eolian::to_c(shadows_enabled_)));
      }

      virtual bool shadows_enable_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_scene_shadows_enable_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

   };
};


template<>
struct operation_description_class_size< ::evas_3d_scene >
{
   static const int value = 15;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::evas_3d_scene>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_evas_3d_scene_update_notify_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::evas_3d_object_update_notify);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_evas_3d_scene_change_notify_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::evas_3d_object_change_notify);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_evas_3d_scene_root_node_get_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::evas_3d_scene_root_node_get);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_evas_3d_scene_root_node_set_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::evas_3d_scene_root_node_set);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::_evas_3d_scene_camera_node_get_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::evas_3d_scene_camera_node_get);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   ops[5].func = reinterpret_cast<void*>(& ::_evas_3d_scene_camera_node_set_wrapper<T>);
   ops[5].api_func = reinterpret_cast<void*>(& ::evas_3d_scene_camera_node_set);
   ops[5].op = EO_OP_OVERRIDE;
   ops[5].op_type = EO_OP_TYPE_REGULAR;
   ops[5].doc = NULL;

   ops[6].func = reinterpret_cast<void*>(& ::_evas_3d_scene_size_set_wrapper<T>);
   ops[6].api_func = reinterpret_cast<void*>(& ::evas_3d_scene_size_set);
   ops[6].op = EO_OP_OVERRIDE;
   ops[6].op_type = EO_OP_TYPE_REGULAR;
   ops[6].doc = NULL;

   ops[7].func = reinterpret_cast<void*>(& ::_evas_3d_scene_size_get_wrapper<T>);
   ops[7].api_func = reinterpret_cast<void*>(& ::evas_3d_scene_size_get);
   ops[7].op = EO_OP_OVERRIDE;
   ops[7].op_type = EO_OP_TYPE_REGULAR;
   ops[7].doc = NULL;

   ops[8].func = reinterpret_cast<void*>(& ::_evas_3d_scene_background_color_set_wrapper<T>);
   ops[8].api_func = reinterpret_cast<void*>(& ::evas_3d_scene_background_color_set);
   ops[8].op = EO_OP_OVERRIDE;
   ops[8].op_type = EO_OP_TYPE_REGULAR;
   ops[8].doc = NULL;

   ops[9].func = reinterpret_cast<void*>(& ::_evas_3d_scene_background_color_get_wrapper<T>);
   ops[9].api_func = reinterpret_cast<void*>(& ::evas_3d_scene_background_color_get);
   ops[9].op = EO_OP_OVERRIDE;
   ops[9].op_type = EO_OP_TYPE_REGULAR;
   ops[9].doc = NULL;

   ops[10].func = reinterpret_cast<void*>(& ::_evas_3d_scene_pick_wrapper<T>);
   ops[10].api_func = reinterpret_cast<void*>(& ::evas_3d_scene_pick);
   ops[10].op = EO_OP_OVERRIDE;
   ops[10].op_type = EO_OP_TYPE_REGULAR;
   ops[10].doc = NULL;

   ops[11].func = reinterpret_cast<void*>(& ::_evas_3d_scene_exist_wrapper<T>);
   ops[11].api_func = reinterpret_cast<void*>(& ::evas_3d_scene_exist);
   ops[11].op = EO_OP_OVERRIDE;
   ops[11].op_type = EO_OP_TYPE_REGULAR;
   ops[11].doc = NULL;

   ops[12].func = reinterpret_cast<void*>(& ::_evas_3d_scene_pick_member_list_get_wrapper<T>);
   ops[12].api_func = reinterpret_cast<void*>(& ::evas_3d_scene_pick_member_list_get);
   ops[12].op = EO_OP_OVERRIDE;
   ops[12].op_type = EO_OP_TYPE_REGULAR;
   ops[12].doc = NULL;

   ops[13].func = reinterpret_cast<void*>(& ::_evas_3d_scene_shadows_enable_set_wrapper<T>);
   ops[13].api_func = reinterpret_cast<void*>(& ::evas_3d_scene_shadows_enable_set);
   ops[13].op = EO_OP_OVERRIDE;
   ops[13].op_type = EO_OP_TYPE_REGULAR;
   ops[13].doc = NULL;

   ops[14].func = reinterpret_cast<void*>(& ::_evas_3d_scene_shadows_enable_get_wrapper<T>);
   ops[14].api_func = reinterpret_cast<void*>(& ::evas_3d_scene_shadows_enable_get);
   ops[14].op = EO_OP_OVERRIDE;
   ops[14].op_type = EO_OP_TYPE_REGULAR;
   ops[14].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::evas_3d_scene >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::evas_3d_scene, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

inline void
call_constructor(tag< ::evas_3d_scene >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::evas_3d_scene, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::evas_3d_scene>
{
   template <typename U>
   struct type
   {
      operator ::evas_3d_scene() const
      {
         return ::evas_3d_scene(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      void update_notify()
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_3d_object_update_notify());
      }

      void change_notify(Evas_3D_State state_, Evas_3D_Object * ref_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_3d_object_change_notify(state_, ref_));
      }

      Evas_3D_Node * root_node_get()
      {
         Evas_3D_Node * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::evas_3d_scene_root_node_get());
            return _tmp_ret;
      }

      void root_node_set(Evas_3D_Node * node_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_3d_scene_root_node_set(node_));
      }

      Evas_3D_Node * camera_node_get()
      {
         Evas_3D_Node * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::evas_3d_scene_camera_node_get());
            return _tmp_ret;
      }

      void camera_node_set(Evas_3D_Node * node_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_3d_scene_camera_node_set(node_));
      }

      void size_set(int w_, int h_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_3d_scene_size_set(w_, h_));
      }

      void size_get(int* w_, int* h_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_3d_scene_size_get(w_, h_));
      }

      void background_color_set(Evas_Real r_, Evas_Real g_, Evas_Real b_, Evas_Real a_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_3d_scene_background_color_set(r_, g_, b_, a_));
      }

      void background_color_get(Evas_Real* r_, Evas_Real* g_, Evas_Real* b_, Evas_Real* a_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_3d_scene_background_color_get(r_, g_, b_, a_));
      }

      bool pick(Evas_Real x_, Evas_Real y_, Evas_3D_Node ** node_, Evas_3D_Mesh ** mesh_, Evas_Real* s_, Evas_Real* t_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::evas_3d_scene_pick(x_, y_, node_, mesh_, s_, t_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      Evas_3D_Node * exist(Evas_Real x_, Evas_Real y_, Evas_3D_Node * node_)
      {
         Evas_3D_Node * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::evas_3d_scene_exist(x_, y_, node_));
            return _tmp_ret;
      }

      efl::eina::range_list< Evas_3D_Node * > pick_member_list_get(Evas_Real x_, Evas_Real y_)
      {
         Eina_List * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::evas_3d_scene_pick_member_list_get(x_, y_));
            return efl::eolian::to_cxx<efl::eina::range_list< Evas_3D_Node * >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
      }

      void shadows_enable_set(bool shadows_enabled_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_3d_scene_shadows_enable_set(efl::eolian::to_c(shadows_enabled_)));
      }

      bool shadows_enable_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::evas_3d_scene_shadows_enable_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

   };
};

inline Eo_Class const* get_eo_class(tag<::evas_3d_scene>)
{
   return (EVAS_3D_SCENE_CLASS);
}

} } }
#endif // EFL_GENERATED_EVAS_3D_SCENE_HH

